// Black Forest (Winter) Clone v1.0
// Made by krad7 (Recevied some help from petard_rusher)
/*
 * Features:
 * 1. Mother nature helps boost the economy by providing Rain once in a while..
 * 2. Mother nature uses Cease fire once in 15-20mins.
 * 3. Day and Night effect. Players cannot see their allies during dusk and night time.
 *		a. Nights longer.
 * 4. Snows occasionaly and sometimes heavily..
 */

// Main entry point for random map script
void main(void)
{

int _krRainDelay		= rmRandInt(180,210);
int _krCeasefireDelay	= rmRandInt(900,1200);
int _krSnowLen			= rmRandInt(120,140);
int _krSnowDelay		= rmRandInt(120,150);
int _krDayLen = 160;
int _krDuskLen = 25;
int _krNightLen = 60;
int _krDawnLen = 25;

// Define triggers
	rmCreateTrigger("_krDawn");
	rmCreateTrigger("_krDay");
	rmCreateTrigger("_krDusk");
	rmCreateTrigger("_krNight");

	rmCreateTrigger("God_Power_Rain_Start");
	rmCreateTrigger("God_Power_Rain_Stop");
	rmCreateTrigger("God_Power_CeaseFire_Start");
	rmCreateTrigger("God_Power_CeaseFire_Stop");
	rmCreateTrigger("Snow_fall_Start");
	rmCreateTrigger("Snow_fall_Stop");

	/* Cease fire */
	rmSwitchToTrigger(rmTriggerID("God_Power_CeaseFire_Start"));
	rmSetTriggerActive(true);
	
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", _krCeasefireDelay);

	rmAddTriggerEffect("Grant God Power");
	rmSetTriggerEffectParamInt("PlayerID", 0);
	rmSetTriggerEffectParam("PowerName","Cease fire");

	rmAddTriggerEffect("Invoke God Power");
	rmSetTriggerEffectParamInt("PlayerID", 0);
	rmSetTriggerEffectParam("PowerName","Cease fire");
	rmSetTriggerEffectParam("DstPoint1","1,1,1");

	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", rmRandInt(10,15));
	rmAddTriggerEffect("Fire Event");
	rmSetTriggerEffectParamInt("EventID", rmTriggerID("God_Power_CeaseFire_Stop"));


	rmSwitchToTrigger(rmTriggerID("God_Power_CeaseFire_Stop"));
	rmSetTriggerActive(false);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", rmRandInt(10,15));
	rmAddTriggerEffect("Fire Event");
	rmSetTriggerEffectParamInt("EventID", rmTriggerID("God_Power_CeaseFire_Start"));
	/* End of Cease fire */

	/* Rain GP */
	rmSwitchToTrigger(rmTriggerID("God_Power_Rain_Start"));
	rmSetTriggerActive(true);
	
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", rmRandInt(10,15));

	rmAddTriggerEffect("Grant God Power");
	rmSetTriggerEffectParamInt("PlayerID", 0);
	rmSetTriggerEffectParam("PowerName","Rain");

	rmAddTriggerEffect("Invoke God Power");
	rmSetTriggerEffectParamInt("PlayerID", 0);
	rmSetTriggerEffectParam("PowerName","Rain");
	rmSetTriggerEffectParam("DstPoint1","1,1,1");

	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", _krRainDelay);
	rmAddTriggerEffect("Fire Event");
	rmSetTriggerEffectParamInt("EventID", rmTriggerID("God_Power_Rain_Stop"));


	rmSwitchToTrigger(rmTriggerID("God_Power_Rain_Stop"));
	rmSetTriggerActive(false);
	
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", rmRandInt(10,15));
	rmAddTriggerEffect("Fire Event");
	rmSetTriggerEffectParamInt("EventID", rmTriggerID("God_Power_Rain_Start"));
	/* End of Rain GP */

	/* Snow fall */
	/* start */
	rmSwitchToTrigger(rmTriggerID("Snow_fall_Start"));
	rmSetTriggerActive(true);

	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", _krSnowDelay);
	
	rmAddTriggerEffect("Render snow");
	rmSetTriggerEffectParamFloat("Percent",rmRandFloat(30.0,80.0));
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", rmRandInt(10,15));
	rmAddTriggerEffect("Fire Event");
	rmSetTriggerEffectParamInt("EventID", rmTriggerID("Snow_fall_Stop"));

	/* Stop */
	rmSwitchToTrigger(rmTriggerID("Snow_fall_Stop"));
	rmSetTriggerActive(false);

	rmAddTriggerEffect("Render snow");
	rmSetTriggerEffectParamFloat("Percent",0.0);

	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", rmRandInt(10,15));

	rmAddTriggerEffect("Fire Event");
	rmSetTriggerEffectParamInt("EventID", rmTriggerID("Snow_fall_Start"));
	/* End of snow fall */

	/* Dawn */
	
	rmSwitchToTrigger(rmTriggerID("_krDawn"));
	rmSetTriggerActive(false);

	for(i=1; <cNumberPlayers)
	{
		int _myTeam = rmGetPlayerTeam(i);
		for(j=1; <cNumberPlayers)
		{
			int _otherTeam = rmGetPlayerTeam(j);
			if(i==j)
			{
			}
			else
			{
				if(_myTeam==_otherTeam)
				{
					rmAddTriggerEffect("Player LOS Change");
					rmSetTriggerEffectParamInt("Player1",i);
					rmSetTriggerEffectParam("CanSee","true");
					rmSetTriggerEffectParamInt("Player2",j);
				}
			}
		}
	}

	rmAddTriggerEffect("Message");
	rmSetTriggerEffectParam("Text","Dawn");
	rmSetTriggerEffectParamInt("Timeout",5000);

	rmAddTriggerEffect("Set Lighting");
	rmSetTriggerEffectParam("SetName","dawn");
	rmSetTriggerEffectParamFloat("FadeTime",_krDawnLen);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", _krDawnLen);
	rmAddTriggerEffect("Fire Event");
	rmSetTriggerEffectParamInt("EventID", rmTriggerID("_krDay"));
	
	/* End of Dawn */

	/* Day */
	rmSwitchToTrigger(rmTriggerID("_krDay"));
	rmSetTriggerActive(true);

	rmAddTriggerEffect("Message");
	rmSetTriggerEffectParam("Text","Day");
	rmSetTriggerEffectParamInt("Timeout",5000);

	rmAddTriggerEffect("Set Lighting");
	rmSetTriggerEffectParam("SetName","alfheim");
	rmSetTriggerEffectParamFloat("FadeTime",_krDayLen);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", _krDayLen);
	rmAddTriggerEffect("Fire Event");
	rmSetTriggerEffectParamInt("EventID", rmTriggerID("_krDusk"));
	/* End of Day */

	/* Dusk */
	rmSwitchToTrigger(rmTriggerID("_krDusk"));
	rmSetTriggerActive(false);


	for(i=1; <cNumberPlayers)
	{
		int _myTeam1 = rmGetPlayerTeam(i);
		for(j=1; <cNumberPlayers)
		{
			int _otherTeam1 = rmGetPlayerTeam(j);
			if(i==j)
			{
			}
			else
			{
				if(_myTeam1==_otherTeam1)
				{
					rmAddTriggerEffect("Player LOS Change");
					rmSetTriggerEffectParamInt("Player1",i);
					rmSetTriggerEffectParam("CanSee","false");
					rmSetTriggerEffectParamInt("Player2",j);
				}
			}
		}
	}

	rmAddTriggerEffect("Message");
	rmSetTriggerEffectParam("Text","Dusk");
	rmSetTriggerEffectParamInt("Timeout",5000);

	rmAddTriggerEffect("Set Lighting");
	rmSetTriggerEffectParam("SetName","dusk");
	rmSetTriggerEffectParamFloat("FadeTime",_krDuskLen);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", _krDuskLen);
	rmAddTriggerEffect("Fire Event");
	rmSetTriggerEffectParamInt("EventID", rmTriggerID("_krNight"));
	/* End of Dusk */

	/* Night */
	rmSwitchToTrigger(rmTriggerID("_krNight"));
	rmSetTriggerActive(false);

	rmAddTriggerEffect("Message");
	rmSetTriggerEffectParam("Text","Night");
	rmSetTriggerEffectParamInt("Timeout",5000);

	rmAddTriggerEffect("Set Lighting");
	rmSetTriggerEffectParam("SetName","night");
	rmSetTriggerEffectParamFloat("FadeTime",_krNightLen);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", _krNightLen);
	rmAddTriggerEffect("Fire Event");
	rmSetTriggerEffectParamInt("EventID", rmTriggerID("_krDawn"));
	/* End of Dusk */

rmAddTriggerCondition("Timer");
rmSetTriggerConditionParamInt("Param1", 1);

// ----------------------------------------------DONE WITH TRIGGERS------------------------------


   // Text
   rmSetStatusText("First, there was a void... ",0.01);
   rmEchoInfo("Map name: Alfheim");

   // Set size.
   int playerTiles=8000;
   if(cMapSize == 1)
   {
      playerTiles = 9750;
      rmEchoInfo("Large map");
   }
   int size=2.3*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);

   // Set up default water.
   rmSetSeaLevel(0.0);

   // Init map.
   rmTerrainInitialize("snowgrass50");
   rmSetLightingSet("alfheim");
   rmSetGaiaCiv(cCivZeus);

   // Define some classes.
   int classPlayer=rmDefineClass("player");
   rmDefineClass("classHill");
   rmDefineClass("starting settlement");
   int classCliff=rmDefineClass("cliff");
   int classConnection=rmDefineClass("connection");

    // -------------Define constraints

   // Create a edge of map constraint.
   int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(8), rmZTilesToFraction(8), 1.0-rmXTilesToFraction(8), 1.0-rmZTilesToFraction(8));

   // Player area constraint.
   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20);
   int playerConstraint2=rmCreateClassDistanceConstraint("stay away from players2", classPlayer, 1);

   //Connection Constraint
   int connectionConstraint=rmCreateClassDistanceConstraint("stay away from connection", classConnection, 2);

   // Settlement constraint.
   int shortAvoidSettlement2=rmCreateTypeDistanceConstraint("objects avoid TC by short distance2", "AbstractSettlement", 15.0);
   int shortAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by short distance", "AbstractSettlement", 20.0);
   int farAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by long distance", "AbstractSettlement", 50.0);
   int farStartingSettleConstraint=rmCreateClassDistanceConstraint("objects avoid player TCs", rmClassID("starting settlement"), 50.0);

   // Tower constraint.
   int avoidTower=rmCreateTypeDistanceConstraint("towers avoid towers", "tower", 28.0);
   int avoidTower2=rmCreateTypeDistanceConstraint("objects avoid towers", "tower", 25.0);

   // Gold
   int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 30.0);
   int shortAvoidGold=rmCreateTypeDistanceConstraint("gold vs. gold", "gold", 24.0);

   // Herd animals
   int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 20.0);
   int avoidFood=rmCreateTypeDistanceConstraint("avoid food", "food", 6.0);
   int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 40.0);

   // Avoid impassable land
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "land", false, 8.0);
   int avoidImpassableLand1=rmCreateTerrainDistanceConstraint("avoid impassable land", "land", false, 1.0);
   int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "land", false, 4.0);
   int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 20.0);
   int cliffConstraint=rmCreateClassDistanceConstraint("cliff v cliff", rmClassID("cliff"), 20.0);
   int shortCliffConstraint=rmCreateClassDistanceConstraint("stuff v cliff", rmClassID("cliff"), 10.0);



   // -------------Define objects
   // Close Objects

   
   int startingSettlementID=rmCreateObjectDef("Starting settlement");
   rmAddObjectDefItem(startingSettlementID, "Settlement Level 1", 1, 0.0);
   rmAddObjectDefToClass(startingSettlementID, rmClassID("starting settlement"));
   rmSetObjectDefMinDistance(startingSettlementID, 0.0);
   rmSetObjectDefMaxDistance(startingSettlementID, 0.0);

   // Settlement avoids gold, Settlements
   int farSettlementID=rmCreateObjectDef("far settlement");
   rmAddObjectDefItem(farSettlementID, "Settlement", 1, 0.0);
   rmSetObjectDefMinDistance(farSettlementID, 50.0);
   rmSetObjectDefMaxDistance(farSettlementID, 70);
   rmAddObjectDefConstraint(farSettlementID, farAvoidSettlement);
   rmAddObjectDefConstraint(farSettlementID, avoidImpassableLand);


   // towers avoid other towers
   int startingTowerID=rmCreateObjectDef("Starting tower");
   rmAddObjectDefItem(startingTowerID, "tower", 1, 0.0);
   rmSetObjectDefMinDistance(startingTowerID, 28.0);
   rmSetObjectDefMaxDistance(startingTowerID, 28.0);
   rmAddObjectDefConstraint(startingTowerID, avoidTower);

   // gold avoids gold
   int startingGoldID=rmCreateObjectDef("Starting gold");
   rmAddObjectDefItem(startingGoldID, "Gold mine small", 1, 0.0);
   rmSetObjectDefMinDistance(startingGoldID, 34.0);
   rmSetObjectDefMaxDistance(startingGoldID, 40.0);
   rmAddObjectDefConstraint(startingGoldID, avoidGold);
   rmAddObjectDefConstraint(startingGoldID, shortCliffConstraint);

   int closeCowsID=rmCreateObjectDef("close Cows");
   rmAddObjectDefItem(closeCowsID, "cow", rmRandInt(2,4), 2.0);
   rmSetObjectDefMinDistance(closeCowsID, 20.0);
   rmSetObjectDefMaxDistance(closeCowsID, 25.0);
   rmAddObjectDefConstraint(closeCowsID, shortCliffConstraint);
   rmAddObjectDefConstraint(closeCowsID, avoidFood);

   int BerryNum=rmRandInt(6, 10);
   int closeChickensID=rmCreateObjectDef("close Chickens");
   rmAddObjectDefItem(closeChickensID, "chicken", BerryNum, 5.0);
   rmSetObjectDefMinDistance(closeChickensID, 20.0);
   rmSetObjectDefMaxDistance(closeChickensID, 25.0);
   rmAddObjectDefConstraint(closeChickensID, shortCliffConstraint);

   int avoidChickens=rmCreateTypeDistanceConstraint("avoid chickens", "chicken", 10.0);
   int closeBerriesID=rmCreateObjectDef("close berries");
   rmAddObjectDefItem(closeBerriesID, "berry bush", BerryNum, 4.0);
   rmSetObjectDefMinDistance(closeBerriesID, 20.0);
   rmSetObjectDefMaxDistance(closeBerriesID, 25.0);
   rmAddObjectDefConstraint(closeBerriesID, shortCliffConstraint);
   rmAddObjectDefConstraint(closeBerriesID, avoidChickens);
   
   int closeElkID=rmCreateObjectDef("close elk");
   rmAddObjectDefItem(closeElkID, "elk", rmRandInt(3,5), 4.0);
   rmSetObjectDefMinDistance(closeElkID, 30.0);
   rmSetObjectDefMaxDistance(closeElkID, 50.0);
   rmAddObjectDefConstraint(closeElkID, shortCliffConstraint);
   rmAddObjectDefConstraint(closeElkID, shortAvoidSettlement);
   
   int stragglerTreeID=rmCreateObjectDef("straggler tree");
   rmAddObjectDefItem(stragglerTreeID, "pine snow", 1, 0.0);
   rmSetObjectDefMinDistance(stragglerTreeID, 12.0);
   rmSetObjectDefMaxDistance(stragglerTreeID, 15.0);

   // Medium Objects

   // Text
   rmSetStatusText("Until the earth and heavens were formed...",0.10);

   // gold avoids gold and Settlements
   int mediumGoldID=rmCreateObjectDef("medium gold");
   rmAddObjectDefItem(mediumGoldID, "Gold mine", 1, 0.0);
   rmSetObjectDefMinDistance(mediumGoldID, 40.0);
   rmSetObjectDefMaxDistance(mediumGoldID, 60.0);
   rmAddObjectDefConstraint(mediumGoldID, shortAvoidGold);
   rmAddObjectDefConstraint(mediumGoldID, shortAvoidSettlement);
   rmAddObjectDefConstraint(mediumGoldID, shortCliffConstraint);
   rmAddObjectDefConstraint(mediumGoldID, farStartingSettleConstraint);

   int mediumCowID=rmCreateObjectDef("medium Cow");
   rmAddObjectDefItem(mediumCowID, "cow", rmRandFloat(2,3), 4.0);
   rmSetObjectDefMinDistance(mediumCowID, 50.0);
   rmSetObjectDefMaxDistance(mediumCowID, 75.0);
   rmAddObjectDefConstraint(mediumCowID, shortCliffConstraint);
   rmAddObjectDefConstraint(mediumCowID, farStartingSettleConstraint); 

   int mediumDeerID=rmCreateObjectDef("medium deer");
   rmAddObjectDefItem(mediumDeerID, "deer", rmRandInt(4,8), 4.0);
   rmSetObjectDefMinDistance(mediumDeerID, 60.0);
   rmSetObjectDefMaxDistance(mediumDeerID, 80.0);
   rmAddObjectDefConstraint(mediumDeerID, shortCliffConstraint);
   rmAddObjectDefConstraint(mediumDeerID, avoidFood);
   rmAddObjectDefConstraint(mediumDeerID, farStartingSettleConstraint);   
   

   // Far Objects

   // gold avoids gold, Settlements and TCs
   int farGoldID=rmCreateObjectDef("far gold");
   rmAddObjectDefItem(farGoldID, "Gold mine", 1, 0.0);
   rmSetObjectDefMinDistance(farGoldID, 80.0);
   rmSetObjectDefMaxDistance(farGoldID, 150.0);
   rmAddObjectDefConstraint(farGoldID, shortAvoidGold);
   rmAddObjectDefConstraint(farGoldID, shortCliffConstraint);
   rmAddObjectDefConstraint(farGoldID, shortAvoidSettlement);
   rmAddObjectDefConstraint(farGoldID, farStartingSettleConstraint);
  
   int farCowID=rmCreateObjectDef("far Cow");
   rmAddObjectDefItem(farCowID, "cow", rmRandInt(1,2), 4.0);
   rmSetObjectDefMinDistance(farCowID, 80.0);
   rmSetObjectDefMaxDistance(farCowID, 150.0);
   rmAddObjectDefConstraint(farCowID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(farCowID, shortCliffConstraint);
   rmAddObjectDefConstraint(farCowID, avoidHerdable);

   // pick wolves or bears as predators
   // avoid TCs and other animals
   int farPredatorID=rmCreateObjectDef("far predator");
   float predatorSpecies=rmRandFloat(0, 1);
   if(predatorSpecies<0.5)   
      rmAddObjectDefItem(farPredatorID, "wolf", 2, 4.0);
   else
      rmAddObjectDefItem(farPredatorID, "bear", 1, 4.0);
   rmSetObjectDefMinDistance(farPredatorID, 50.0);
   rmSetObjectDefMaxDistance(farPredatorID, 100.0);
   rmAddObjectDefConstraint(farPredatorID, avoidPredator);
   rmAddObjectDefConstraint(farPredatorID, farStartingSettleConstraint); 
   rmAddObjectDefConstraint(farPredatorID, shortCliffConstraint);
   rmAddObjectDefConstraint(farPredatorID, avoidFood);

   // This map will either use boar or deer as the extra huntable food.
   int classBonusHuntable=rmDefineClass("bonus huntable");
   int avoidBonusHuntable=rmCreateClassDistanceConstraint("avoid bonus huntable", classBonusHuntable, 40.0);
   int avoidHuntable=rmCreateTypeDistanceConstraint("avoid huntable", "huntable", 20.0);

   // hunted avoids hunted and TCs
   int bonusHuntableID=rmCreateObjectDef("bonus huntable");
   float bonusChance=rmRandFloat(0, 1);
   if(bonusChance<0.5)   
      rmAddObjectDefItem(bonusHuntableID, "elk", 6, 4.0);
   else
      rmAddObjectDefItem(bonusHuntableID, "caribou", 6, 4.0);
   rmSetObjectDefMinDistance(bonusHuntableID, 0.0);
   rmSetObjectDefMaxDistance(bonusHuntableID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(bonusHuntableID, avoidBonusHuntable);
   rmAddObjectDefConstraint(bonusHuntableID, avoidHuntable);
   rmAddObjectDefToClass(bonusHuntableID, classBonusHuntable);
   rmAddObjectDefConstraint(bonusHuntableID, farStartingSettleConstraint); 
   rmAddObjectDefConstraint(bonusHuntableID, shortCliffConstraint);
   
   int randomTreeID=rmCreateObjectDef("random tree");
   rmAddObjectDefItem(randomTreeID, "pine snow", 1, 0.0);
   rmSetObjectDefMinDistance(randomTreeID, 0.0);
   rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 4.0));
   rmAddObjectDefConstraint(randomTreeID, shortAvoidSettlement);
   rmAddObjectDefConstraint(randomTreeID, shortAvoidImpassableLand);

    // Birds
   int farhawkID=rmCreateObjectDef("far hawks");
   rmAddObjectDefItem(farhawkID, "hawk", 1, 0.0);
   rmSetObjectDefMinDistance(farhawkID, 0.0);
   rmSetObjectDefMaxDistance(farhawkID, rmXFractionToMeters(0.5));
// Relics avoid TCs
   int relicID=rmCreateObjectDef("relic");
   rmAddObjectDefItem(relicID, "relic", 1, 0.0);
   rmSetObjectDefMinDistance(relicID, 60.0);
   rmSetObjectDefMaxDistance(relicID, 150.0);
   rmAddObjectDefConstraint(relicID, rmCreateTypeDistanceConstraint("relic vs relic", "relic", 70.0));
   rmAddObjectDefConstraint(relicID, playerConstraint);
   rmAddObjectDefConstraint(relicID, avoidImpassableLand);

   // -------------Done defining objects

   // Cheesy "circular" placement of players.
   rmSetTeamSpacingModifier(0.75);
   rmPlacePlayersCircular(0.3, 0.4, rmDegreesToRadians(5.0));

   // Connections
   int rampID=rmCreateConnection("ramps");
   if(cNumberNonGaiaPlayers < 5)
     rmSetConnectionType(rampID, cConnectAreas, true, 1.0);
   else
     rmSetConnectionType(rampID, cConnectAreas, false, 2.0);

   rmSetConnectionWidth(rampID, 12, 2);
   rmSetConnectionSmoothDistance(rampID, 3.0);
   rmAddConnectionToClass(rampID, classConnection);

   // Set up player areas.
   float playerFraction=rmAreaTilesToFraction(4000);
   for(i=1; <cNumberPlayers)
   {
      // Create the area.
      int id=rmCreateArea("Player"+i);

      // Assign to the player.
      rmSetPlayerArea(i, id);

      // Set the size.
      rmSetAreaSize(id, 0.9*playerFraction, 1.1*playerFraction);

      rmAddAreaToClass(id, classPlayer);
      rmSetAreaWarnFailure(id, false);

      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 5);
      rmSetAreaMinBlobDistance(id, 16.0);
      rmSetAreaMaxBlobDistance(id, 40.0);
      rmSetAreaCoherence(id, 0.0);

      //rmSetAreaBaseHeight(id, 4.0);

      // Add constraints.
      rmAddAreaConstraint(id, playerConstraint);

      // Set the location.
      rmSetAreaLocPlayer(id, i);
      rmAddConnectionArea(rampID, id);

      // Set type.
      rmSetAreaTerrainType(id, "snowgrass50");
      rmAddAreaTerrainLayer(id, "snowgrass75", 8, 20);
      rmAddAreaTerrainLayer(id, "snowgrass50", 0, 8);

   }

   rmBuildConnection(rampID);

   // Build the areas.
   rmBuildAllAreas();

   for(i=1; <cNumberPlayers)
   {
      // Beautification sub area.
      int id2=rmCreateArea("Player inner"+i, rmAreaID("player"+i));
      rmSetAreaSize(id2, rmAreaTilesToFraction(200), rmAreaTilesToFraction(300));
      rmSetAreaLocPlayer(id2, i);
      rmSetAreaTerrainType(id2, "snowgrass75");
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 5);
      rmSetAreaMinBlobDistance(id2, 16.0);
      rmSetAreaMaxBlobDistance(id2, 40.0);
      rmSetAreaCoherence(id2, 0.0);

      rmBuildArea(id2); 
   } 

      for(i=1; <cNumberPlayers*20)
   {
      // Beautification sub area.
      int id4=rmCreateArea("snow patch 2 "+i);
      rmSetAreaSize(id4, rmAreaTilesToFraction(5), rmAreaTilesToFraction(16));
      rmSetAreaTerrainType(id4, "snowgrass25");
      rmSetAreaMinBlobs(id4, 1);
      rmSetAreaMaxBlobs(id4, 5);
      rmSetAreaWarnFailure(id4, false);
      rmSetAreaMinBlobDistance(id4, 16.0);
      rmSetAreaMaxBlobDistance(id4, 40.0);
      rmSetAreaCoherence(id4, 0.0);

      rmBuildArea(id4);
   }

   for(i=1; <cNumberPlayers*12)
   {
      // Beautification sub area.
      int id5=rmCreateArea("snow patch 3 "+i);
      rmSetAreaSize(id5, rmAreaTilesToFraction(5), rmAreaTilesToFraction(20));
      rmSetAreaTerrainType(id5, "snowgrass75");
      rmSetAreaMinBlobs(id5, 1);
      rmSetAreaMaxBlobs(id5, 5);
      rmSetAreaWarnFailure(id5, false);
      rmSetAreaMinBlobDistance(id5, 16.0);
      rmSetAreaMaxBlobDistance(id5, 40.0);
      rmSetAreaCoherence(id5, 0.0);

      rmBuildArea(id5);
   }



      // Text
   rmSetStatusText("Great treasures lay hidden in secret glades ",0.30);

   // Place starting settlements.
   // Close things....
   // TC
   rmPlaceObjectDefPerPlayer(startingSettlementID, true);

   rmPlaceObjectDefPerPlayer(farSettlementID, false, 5);

   // Text
   rmSetStatusText("Protected by beasts most foul",0.40);

   // Towers.
   rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);


   // Slight Elevation
   int numTries=30*cNumberNonGaiaPlayers;
   int failCount=0;
   for(i=0; <numTries)
   {
      int elevID=rmCreateArea("wrinkle"+i);
      rmSetAreaSize(elevID, rmAreaTilesToFraction(15), rmAreaTilesToFraction(120));
      rmSetAreaLocation(elevID, rmRandFloat(0.0, 1.0), rmRandFloat(0.0, 1.0));
      rmSetAreaWarnFailure(elevID, false);
      rmSetAreaBaseHeight(elevID, rmRandFloat(2.0, 4.0));
      rmAddAreaConstraint(elevID, avoidBuildings);
      rmSetAreaMinBlobs(elevID, 1);
      rmSetAreaMaxBlobs(elevID, 3);
      rmSetAreaMinBlobDistance(elevID, 16.0);
      rmSetAreaMaxBlobDistance(elevID, 20.0);
      rmSetAreaCoherence(elevID, 0.0);

      if(rmBuildArea(elevID)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==3)
            break;
      }
      else
         failCount=0;
   }

   // Elev.
   numTries=10*cNumberNonGaiaPlayers;
   failCount=0;
   for(i=0; <numTries)
   {
      elevID=rmCreateArea("elev"+i);
      rmSetAreaSize(elevID, rmAreaTilesToFraction(15), rmAreaTilesToFraction(120));
      rmSetAreaLocation(elevID, rmRandFloat(0.0, 1.0), rmRandFloat(0.0, 1.0));
      rmSetAreaWarnFailure(elevID, false);
      rmAddAreaConstraint(elevID, avoidBuildings);
      rmSetAreaBaseHeight(elevID, rmRandFloat(3.0, 4.0));
      rmAddAreaConstraint(elevID, cliffConstraint);
      rmSetAreaMinBlobs(elevID, 1);
      rmSetAreaMaxBlobs(elevID, 5);
      rmSetAreaMinBlobDistance(elevID, 16.0);
      rmSetAreaMaxBlobDistance(elevID, 40.0);
      rmSetAreaCoherence(elevID, 0.0);

      if(rmBuildArea(elevID)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==3)
            break;
      }
      else
         failCount=0;
   }

   // Straggler trees.
   rmPlaceObjectDefPerPlayer(stragglerTreeID, false, rmRandInt(2, 5));


   // Gold
   rmPlaceObjectDefPerPlayer(startingGoldID, false);

   // cows
   rmPlaceObjectDefPerPlayer(closeCowsID, true);
   
   // chickens and berries   
   rmPlaceObjectDefPerPlayer(closeChickensID, false);

   rmPlaceObjectDefPerPlayer(closeBerriesID, false);

   // Boar.
   rmPlaceObjectDefPerPlayer(closeElkID, false);

   // Medium things....
   // Gold
   rmPlaceObjectDefPerPlayer(mediumGoldID, false, 6);

// Relics
   rmPlaceObjectDefPerPlayer(relicID, false, 40);


   // Herds.
   rmPlaceObjectDefPerPlayer(mediumCowID, false, 2); 

   // Deer.
   for(i=1; <cNumberPlayers)
      rmPlaceObjectDefAtLoc(mediumDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
            
   // Far things.

   // Gold.
   rmPlaceObjectDefPerPlayer(farGoldID, false, rmRandInt(3, 4));

   // Bonus huntable.
   rmPlaceObjectDefPerPlayer(bonusHuntableID, false, 1);

   // Herds.
   rmPlaceObjectDefPerPlayer(farCowID, false, 1);

   // Predators
   rmPlaceObjectDefPerPlayer(farPredatorID, false, 1);

   // Hawks
   rmPlaceObjectDefPerPlayer(farhawkID, false, 2); 
   
   // Text
   rmSetStatusText("From the greed of mortals ",0.50);

  
	// Forest.
   int classForest1=rmDefineClass("forest1");
   int forestObjConstraint1=rmCreateTypeDistanceConstraint("forest1 obj", "all", 6.0);
   int forestConstraint1=rmCreateClassDistanceConstraint("forest1 v forest1", rmClassID("forest1"), 1.0);
   int forestSettleConstraint1=rmCreateClassDistanceConstraint("forest1 settle", rmClassID("starting settlement"), 45.0);
   int count1=0;
   numTries=10*cNumberNonGaiaPlayers;
   failCount=0;
   for(i=0; <numTries)
   {
      int forestID1=rmCreateArea("forest1"+i);
      rmSetAreaSize(forestID1, rmAreaTilesToFraction(10), rmAreaTilesToFraction(200));
      rmSetAreaWarnFailure(forestID1, false);
      rmSetAreaForestType(forestID1, "snow pine forest");
 //     rmAddAreaConstraint(forestID1, playerConstraint2);
 //     rmAddAreaConstraint(forestID1, avoidImpassableLand1);
      rmAddAreaConstraint(forestID1, shortAvoidSettlement);
 //     rmAddAreaConstraint(forestID1, connectionConstraint);
      rmAddAreaToClass(forestID1, classForest1);
      
      rmSetAreaMinBlobs(forestID1, 1);
      rmSetAreaMaxBlobs(forestID1, 2);
      rmSetAreaMinBlobDistance(forestID1, 1.0);
      rmSetAreaMaxBlobDistance(forestID1, 2.0);
      rmSetAreaCoherence(forestID1,0.0);

      if(rmBuildArea(forestID1)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
      }
      else
         failCount=0;
   }

   int classForest=rmDefineClass("forest2");
   int forestObjConstraint=rmCreateTypeDistanceConstraint("forest2 obj", "all", 6.0);
   int forestConstraint=rmCreateClassDistanceConstraint("forest2 v forest2", rmClassID("forest2"), 15.0);
   int forestSettleConstraint=rmCreateClassDistanceConstraint("forest2 settle", rmClassID("starting settlement"), 45.0);

   numTries=50*cNumberNonGaiaPlayers;
   failCount=0;
   for(i=0; <numTries)
   {
      int forestID=rmCreateArea("forest2"+i);
      rmSetAreaSize(forestID, rmAreaTilesToFraction(400), rmAreaTilesToFraction(1000));
      rmSetAreaWarnFailure(forestID, false);
      rmSetAreaForestType(forestID, "mixed pine forest");
      rmAddAreaConstraint(forestID, playerConstraint2);
      rmAddAreaConstraint(forestID, avoidImpassableLand1);
      rmAddAreaConstraint(forestID, shortAvoidSettlement);
      rmAddAreaConstraint(forestID, connectionConstraint);
      rmAddAreaToClass(forestID, classForest);
      
      rmSetAreaMinBlobs(forestID, 3);
      rmSetAreaMaxBlobs(forestID, 8);
      rmSetAreaMinBlobDistance(forestID, 16.0);
      rmSetAreaMaxBlobDistance(forestID, 26.0);
      rmSetAreaCoherence(forestID,0.0);

      if(rmBuildArea(forestID)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==3)
            break;
      }
      else
         failCount=0;
   }

   // Text
   rmSetStatusText("Humans were created from the dust of the earth... ",0.70);

   // Random trees.
   rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 50*cNumberNonGaiaPlayers);

   
   // Text
   rmSetStatusText("And vanquish those who worshipped other pantheons",0.90);


   // Text
   rmSetStatusText("So began the Age of Mythology",1.00);

}
